/**
 *  \file       acmds/acut_context.h
 *  \brief      \$Id: acut_context.h 1136 2009-05-07 14:55:33Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1136 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

/** \addtogroup acut
 * \{
 */

#ifndef CONTEXT_H
#define CONTEXT_H

#include "msgque.h"
#include "config.h"

/*****************************************************************************/
/*                                                                           */
/*                              context_basic                                */
/*                                                                           */
/*****************************************************************************/

/// \brief the local \b context of the \ref acut tool
struct CutCtxS {

  struct MqS *	msgque;	      ///< \msgqueI
  MQ_INT	fields[256];  ///< fields used to cut, from the <tt>-f \b FIELDS</tt> option

};

/*****************************************************************************/
/*                                                                           */
/*                                context_init                               */
/*                                                                           */
/*****************************************************************************/

enum MqErrorE CutCreate (
  struct MqConfigS  * config,
  struct MqBufferLS * argv,
  struct MqBufferLS * alfa,
  struct MqS ** msgqueP
);

#endif /* CONTEXT_H */

/** \} server */
