/**
 *  \file       acmds/asort.c
 *  \brief      \$Id: asort.c 1033 2009-04-10 10:36:50Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1033 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

/** \ingroup tools
 *  \defgroup asort asort
 *  \{
 *  \brief asort \asort_desc
 *
 *  \verbinclude asort.help
 */

#include "asort_context.h"
#include <stdlib.h>

/*****************************************************************************/
/*                                                                           */
/*                                     main                                  */
/*                                                                           */
/*****************************************************************************/

/// \brief main entry-point for the tool
/// \param argc the number of command-line arguments
/// \param argv the command-line arguments as an array of strings
/// \return the exit number
int
SortMain (
  int argc,
  char **argv
)
{
  // the parent-context
  struct MqS * msgque;
  struct MqBufferLS *largv,*lalfa;	// splitt command-line arguments into 

  // parse command-line
  MqBufferLCreateArgv (argc, argv, &largv, &lalfa);

  // create the context
  MqErrorCheck(SortCreate (MqConfigInit(), largv, lalfa, &msgque));

  // start event-loop and wait forever
  MqProcessEvent (msgque, MQ_TIMEOUT, MQ_WAIT_FOREVER);

  // last command executed in the server
error:
  MqExit (msgque);

  return 0;
}

/** \} asort */
