/**
 *  \file       csmsgque/config.cs
 *  \brief      \$Id: config.cs 103 2009-06-25 14:01:17Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 103 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

using System;
using System.Runtime.InteropServices;

namespace csmsgque {

  public abstract partial class MqS
  {

  // PRIVATE

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigInit")]
    private static extern IntPtr McConfigInit();

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigDup")]
    private static extern IntPtr McConfigDup([In]IntPtr configP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigInitManagedContext")]
    private static extern IntPtr McConfigInitManagedContext([In]IntPtr config, [In]IntPtr self);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigInitName")]
    private static extern void McConfigInitName([In]IntPtr config, [In]string name);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigInitParent")]
    private static extern void McConfigInitParent([In]IntPtr config, [In]IntPtr parent);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigInitMaster")]
    private static extern void McConfigInitMaster([In]IntPtr config, [In]IntPtr master, [In]int master_id);

  // MqConfigGet ...

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetSelfFromManagedContext")]
    private static extern IntPtr McConfigGetSelfFromManagedContext([In]IntPtr configP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, 
	EntryPoint = "MqConfigGetSelfFromManagedContextM")]
    private static extern IntPtr McConfigGetSelfFromManagedContextM([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetIsServer")]
    private static extern bool McConfigGetIsServer([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetIsParent")]
    private static extern bool McConfigGetIsParent([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetIsSlave")]
    private static extern bool McConfigGetIsSlave([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetIsString")]
    private static extern bool McConfigGetIsString([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetIsSilent")]
    private static extern bool McConfigGetIsSilent([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetIsDupAndThread")]
    private static extern bool McConfigGetIsDupAndThread([In]IntPtr configP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetName")]
    private static extern IntPtr McConfigGetName([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetDebug")]
    private static extern int McConfigGetDebug([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetParentM")]
    private static extern IntPtr McConfigGetParentM([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetParent")]
    private static extern IntPtr McConfigGetParent([In]IntPtr configP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetMasterM")]
    private static extern IntPtr McConfigGetMasterM([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqConfigGetMyCtx")]
    private static extern IntPtr McConfigGetMyCtx([In]IntPtr configP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqGetCtxId")]
    private static extern int McGetCtxId([In]IntPtr msgqueP);

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqGetToken")]
    private static extern IntPtr McGetToken([In]IntPtr msgqueP);

  // PUBLIC

    /// \api #MqConfigGetIsServer
    public bool ConfigGetIsServer() {
      return McConfigGetIsServer(msgqueP.Value);
    }

    /// \api #MqConfigGetIsParent
    public bool ConfigGetIsParent() {
      return McConfigGetIsParent(msgqueP.Value);
    }

    /// \api #MqConfigGetIsSlave
    public bool ConfigGetIsSlave() {
      return McConfigGetIsSlave(msgqueP.Value);
    }

    /// \api #MqConfigGetIsString
    public bool ConfigGetIsString() {
      return McConfigGetIsString(msgqueP.Value);
    }

    /// \api #MqConfigGetIsSilent
    public bool ConfigGetIsSilent() {
      return McConfigGetIsSilent(msgqueP.Value);
    }

    /// \api #MqConfigGetName
    public string ConfigGetName() {
      return Marshal.PtrToStringAnsi(McConfigGetName(msgqueP.Value));
    }

    /// \api #MqConfigGetDebug
    public int ConfigGetDebug() {
      return McConfigGetDebug(msgqueP.Value);
    }

    /// \api #MqConfigGetParentM
    public MqS ConfigGetParent() {
      IntPtr parentP = McConfigGetParentM(msgqueP.Value);
      return (parentP == IntPtr.Zero ? null :
		(MqS)GCHandle.FromIntPtr(McConfigGetSelfFromManagedContextM(parentP)).Target
      );
    }

    /// \api #MqConfigGetMasterM
    public MqS ConfigGetMaster() {
      IntPtr masterP = McConfigGetMasterM(msgqueP.Value);
      return (masterP == IntPtr.Zero ? null :
		(MqS)GCHandle.FromIntPtr(McConfigGetSelfFromManagedContextM(masterP)).Target
      );
    }

    /// \api #MqGetCtxId
    public int ConfigGetCtxId() {
      return McGetCtxId(msgqueP.Value);
    }

    /// \api #MqGetToken
    public string ConfigGetToken() {
      return Marshal.PtrToStringAnsi(McGetToken(msgqueP.Value));
    }

  } // END - class "MqS"
} // END - namespace "csmsgque"

