/**
 *  \file       csmsgque/error.cs
 *  \brief      \$Id: error.cs 101 2009-06-24 15:57:01Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 101 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

/*****************************************************************************/
/*                                                                           */
/*                                   error                                   */
/*                                                                           */
/*****************************************************************************/

using System;
using System.Runtime.InteropServices;

namespace csmsgque {

  public abstract partial class MqS
  {
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqErrorGetTextM")]
    private static extern IntPtr McErrorGetText(IntPtr msgqueP);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqErrorResetM")]
    private static extern void McErrorReset(IntPtr msgqueP);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqErrorStackPM")]
    private static extern McErrorE McErrorStackP(IntPtr msgqueP, string func, string file);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqErrorGetCodeM")]
    private static extern McErrorE McErrorGetCode(IntPtr msgqueP);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqErrorCM")]
    private static extern McErrorE McErrorC(IntPtr msgqueP, string proc, int num, string message);

    private void ErrorMqToCsWithCheck(McErrorE err) {
      if (err != McErrorE.MQ_ERROR) return;
      ApplicationException ex = new System.ApplicationException(
	      Marshal.PtrToStringAnsi(McErrorGetText(msgqueP.Value)));
      if (callLevel == 0) McErrorReset(msgqueP.Value);
      throw ex;
     }

    private static McErrorE McErrorStack(IntPtr msgqueP) {
      System.Diagnostics.StackFrame sf = new System.Diagnostics.StackFrame(1);
      //return McErrorStackP(msgqueP, sf.GetMethod().Name, sf.GetFileName());
      return McErrorStackP(msgqueP, sf.GetMethod().Name, "unknown");
    }

    public void ErrorC(string proc, int num, string message) {
      ErrorMqToCsWithCheck(McErrorC(msgqueP.Value, proc, num, message));
    }


  } // END - class "MqS"
} // END - namespace "csmsgque"



