/**
 *  \file       csmsgque/get.cs
 *  \brief      \$Id: get.cs 46 2009-06-04 14:01:00Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 46 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

/*****************************************************************************/
/*                                                                           */
/*                                   read                                    */
/*                                                                           */
/*****************************************************************************/

using System;
using System.Runtime.InteropServices;

namespace csmsgque {

  public abstract partial class MqS
  {

    // PRIVAT

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetYM")]
    private  static extern McErrorE McBufferGetY([In]IntPtr msgqueP, [In]IntPtr buf, out byte outV);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetOM")]
    private  static extern McErrorE McBufferGetO([In]IntPtr msgqueP, [In]IntPtr buf, out MQ_BOL outV);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetSM")]
    private  static extern McErrorE McBufferGetS([In]IntPtr msgqueP, [In]IntPtr buf, out short outV);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetIM")]
    private  static extern McErrorE McBufferGetI([In]IntPtr msgqueP, [In]IntPtr buf, out int outV);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetFM")]
    private  static extern McErrorE McBufferGetF([In]IntPtr msgqueP, [In]IntPtr buf, out float outV);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetWM")]
    private  static extern McErrorE McBufferGetW([In]IntPtr msgqueP, [In]IntPtr buf, out long outV);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetDM")]
    private  static extern McErrorE McBufferGetD([In]IntPtr msgqueP, [In]IntPtr buf, out double outV);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetBM")]
    private  static extern McErrorE McBufferGetB([In]IntPtr msgqueP, [In]IntPtr buf, out IntPtr outV, out int size);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetCM")]
    private  static extern McErrorE McBufferGetC([In]IntPtr msgqueP, [In]IntPtr buf, out IntPtr outV);

    // PUBLIC

    /// \api #MqBufferGetType
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqBufferGetType")]
    public static extern char GetType([In]IntPtr buf);

    /// \api #MqReadL_START on a \e buffer object
    public void GetL_START(IntPtr buf) {
      McReadL_START(msgqueP.Value, buf);
    }

    /// \api #MqReadL_END
    public void GetL_END() {
      McReadL_END(msgqueP.Value);
    }

    /// \api #MqBufferGetY
    public byte GetY(IntPtr buf) {
      byte outV;
      ErrorMqToCsWithCheck(McBufferGetY(msgqueP.Value, buf, out outV));
      return outV;
    }

    /// \api #MqBufferGetO
    public bool GetO(IntPtr buf) {
      MQ_BOL outV;
      ErrorMqToCsWithCheck(McBufferGetO(msgqueP.Value, buf, out outV));
      return (outV == MQ_BOL.MQ_YES ? true : false);
    }

    /// \api #MqBufferGetS
    public short GetS(IntPtr buf) {
      short outV;
      ErrorMqToCsWithCheck(McBufferGetS(msgqueP.Value, buf, out outV));
      return outV;
    }

    /// \api #MqBufferGetI
    public int GetI(IntPtr buf) {
      int outV;
      ErrorMqToCsWithCheck(McBufferGetI(msgqueP.Value, buf, out outV));
      return outV;
    }

    /// \api #MqBufferGetF
    public float GetF(IntPtr buf) {
      float outV;
      ErrorMqToCsWithCheck(McBufferGetF(msgqueP.Value, buf, out outV));
      return outV;
    }

    /// \api #MqBufferGetW
    public long GetW(IntPtr buf) {
      long outV;
      ErrorMqToCsWithCheck(McBufferGetW(msgqueP.Value, buf, out outV));
      return outV;
    }

    /// \api #MqBufferGetD
    public double GetD(IntPtr buf) {
      double outV;
      ErrorMqToCsWithCheck(McBufferGetD(msgqueP.Value, buf, out outV));
      return outV;
    }

    /// \api #MqBufferGetB
    public byte[] GetB(IntPtr buf) {
      IntPtr outV;
      int size;
      ErrorMqToCsWithCheck(McBufferGetB(msgqueP.Value, buf, out outV, out size));
      byte[] outB = new byte[size];
      Marshal.Copy(outV,outB,0,size);
      return outB;
    }

    /// \api #MqBufferGetC
    public string GetC(IntPtr buf) {
      IntPtr outV;
      ErrorMqToCsWithCheck(McBufferGetC(msgqueP.Value, buf, out outV));
      return Marshal.PtrToStringAnsi(outV);
    }

  } // END - class "MqS"
} // END - namespace "csmsgque"

