/**
 *  \file       csmsgque/pointer.cs
 *  \brief      \$Id: pointer.cs 63 2009-06-11 14:44:15Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 63 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

using System;
using System.Runtime.InteropServices;

namespace csmsgque {

public abstract partial class MqS {

  /// \api \ref MqCreateF
  [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
  private delegate McErrorE McCreateF (IntPtr config, IntPtr argv, 
    IntPtr alfa, out IntPtr msgque); 

  /// \api \ref MqDeleteF
  [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
  private delegate void McDeleteF (ref IntPtr msgque);

  /// \api \ref MqExitF
  [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
  private delegate void McExitF (int isThread, int exitcode);

  /// \api \ref MqEventF
  [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
  private delegate McErrorE McEventF (IntPtr context);

  /// \api \ref MqTokenF
  [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
  private delegate McErrorE McTokenF (IntPtr msgque, IntPtr data);

  /// \api \ref MqTokenDataFreeF
  [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
  private delegate void McTokenDataFreeF (IntPtr msgque, IntPtr data);

  /// \api public version from \ref MqTokenF
  public delegate void Callback();
}

// END - NameSpace csmsgque
}


