/**
 *  \file       csmsgque/slave.cs
 *  \brief      \$Id: slave.cs 114 2009-06-28 12:47:27Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 114 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

/*****************************************************************************/
/*                                                                           */
/*                                   read                                    */
/*                                                                           */
/*****************************************************************************/

using System;
using System.Runtime.InteropServices;

namespace csmsgque {

  public abstract partial class MqS
  {

    // PRIVAT

    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqSlaveCreate")]
    private  static extern McErrorE McSlaveCreate([In]IntPtr msgqueP, [In]int id, [In]IntPtr slaveP);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqSlaveDelete")]
    private  static extern McErrorE McSlaveDelete([In]IntPtr msgqueP, [In]int id);
    [DllImport(MSGQUE_DLL, CallingConvention=MSGQUE_CC, CharSet=MSGQUE_CS, EntryPoint = "MqSlaveGet")]
    private  static extern IntPtr McSlaveGet([In]IntPtr msgqueP, [In]int id);

    // PUBLIC

    /// \api #MqSlaveCreate
    public void SlaveCreate(int id, MqS slave) {
      ErrorMqToCsWithCheck(McSlaveCreate(msgqueP.Value, id, slave.msgqueP.Value));
    }

    /// \api #MqSlaveDelete
    public void SlaveDelete(int id) {
      ErrorMqToCsWithCheck(McSlaveDelete(msgqueP.Value, id));
    }

    /// \api #MqSlaveGet
    public MqS SlaveGet(int id) {
      IntPtr slaveP = McSlaveGet (msgqueP.Value, id);
      return (slaveP == IntPtr.Zero ? null :
		(MqS)GCHandle.FromIntPtr(McConfigGetSelfFromManagedContextM(slaveP)).Target
      );
    }

  } // END - class "MqS"
} // END - namespace "csmsgque"

