using System;
using csmsgque;
using System.Collections.Generic;

namespace example {
  sealed class Filter1 : MqS, IFilter {
    static Filter1() {
      name = "filter";
    }

    private List<List<string>> data = new List<List<string>>();

    // used to parse command-line options for initial startup
    public Filter1(string[] argv) : base(argv) { }
    public Filter1() : base() { }

    void IServer.Config() { }

    // service definition
    public void FTR () {
      List<string> d = new List<string>();
      while (ReadItemExists()) {
	d.Add("<" + ReadC() + ">");
      }
      data.Add(d);
    }

    // service definition
    public void EOF () {
      foreach (List<string> d in data) {
	SendSTART();
	foreach (string s in d) {
	  SendC(s);
	}
	SendFTR(10);
      }
    }

    public static void Main(string[] argv) {
      Filter1 srv = new Filter1(argv);
      srv.ProcessEvent(MqS.WAIT.FOREVER);
      srv.Delete();
    }
  }
}
