using System;
using csmsgque;

namespace example {

  sealed class MyServer : MqS, IServer {

    // constructor used to create a 'parent' context
    public MyServer(params string[] argv) : base(argv) {}

    // constructor used to create a client 'child' context
    public MyServer(MyServer parent, params string[] argv) : base(parent, argv) {}

    // constructor used to create a 'worker' context
    public MyServer(MyServer master, int master_id, params string[] argv) : base(master, master_id, argv) {}

    // constructor used to create a server 'child' context
    public MyServer() : base() {}

    // service to serve all incomming requests for token "HLWO"
    public void MyFirstService () {
      SendSTART();
      SendC("Hello World");
      SendRETURN();
    }

    // define a service as link between the token "HLWO" and the callback "MyFirstService"
    void IServer.Config() {
      ServiceCreate("HLWO", MyFirstService);
    }

    static void Main(string[] argv) {
      MyServer srv = new MyServer(argv);
      srv.ProcessEvent(MqS.WAIT.FOREVER);
      srv.Delete();
    }
  }
}
