package example;
import java.util.ArrayList;
import javamsgque.*;

class Filter1 extends MqS implements IFilter {
  public static final String name = "filter";

  private ArrayList<ArrayList<String>> data;

  // used to parse command-line options for initial startup
  public Filter1(String[] argv) {
    super(argv);
  }

  // Factory Constructor
  public Filter1() {
    super();
  }

  public void ServerConfig() {
    data = new ArrayList<ArrayList<String>>();
  }

  // service definition
  public void FTR () {
    ArrayList<String> d = new ArrayList<String>();
    while (ReadGetNumItems() != 0) {
      d.add("<" + ReadC() + ">");
    }
    data.add(d);
  }

  // service definition
  public void EOF () {
    for (ArrayList<String> d: data) {
      SendSTART();
      for (String s: d) {
	SendC(s);
      }
      SendFTR(10);
    }
  }

  public static void main(String[] argv) {
    Filter1 srv = new Filter1(argv);
    srv.ProcessEvent(MqS.WAIT.FOREVER);
    srv.Delete();
  }
}
