package example;

import javamsgque.*;

final class MyServer extends MqS implements IServer {

  // constructor used to create a 'parent' context
  public MyServer(String... argv) { super(argv); }

  // constructor used to create a client 'child' context
  public MyServer(MyServer parent, String... argv) { super(parent, argv); }

  // constructor used to create a 'worker' context
  public MyServer(MyServer master, int master_id, String... argv) { super(master, master_id, argv); }

  // constructor used to create a server 'child' context
  public MyServer() { super(); }

  // service to serve all incomming requests for token "HLWO"
  class MyFirstService implements IService {
    public void Service (MqS ctx) {
      SendSTART();
      SendC("Hello World");
      SendRETURN();
    }
  }

  // define a service as link between the token "HLWO" and the class "MyFirstService"
  public void ServerConfig() {
    ServiceCreate("HLWO", new MyFirstService());
  }

  public static void main(String[] argv) {
    MyServer srv = new MyServer(argv);
    srv.ProcessEvent(MqS.WAIT.FOREVER);
    srv.Delete();
  }
}
