/**
 *  \file       javamsgque/IClient.java
 *  \brief      \$Id: IClient.java 1047 2009-04-15 14:29:58Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1047 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

package javamsgque;

/// \brief Configuration data required for \javamsgque startup
///
/// A \javamsgque client application have to implement the #javamsgque.IClient interface.
///
/// \attention This sre only the Vendor-Default configuration-data.
/// The read the \e final configuration-data use the 
/// \c javamsgque.javamsgque.Config* style functions because the data 
/// can be changed by commandline arguments or other side-effects.
public interface IClient {
  /// \api #MqConfigS::isSilent
  public static final boolean silent  = false;
  /// \api #MqConfigS::isString
  public static final boolean string  = false;
  /// \api #MqConfigS::isServer
  /// \attention the #javamsgque.IServer set this value to \e true
  public static final boolean server  = false;
  /// \api #MqConfigS::isFilter
  public static final boolean filter  = false;
  /// \api #MqConfigS::name
  public static final String name     = "java";
  /// \api #MqConfigS::debug
  public static final int debug       = 0;
  /// \api #MqConfigS::buffersize
  public static final int buffersize  = 4094;
  /// \api #MqConfigS::timeout
  public static final int timeout     = 5;
} ;


