/**
 *  \file       javamsgque/IFilter.java
 *  \brief      \$Id: IFilter.java 1047 2009-04-15 14:29:58Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1047 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

package javamsgque;

/// \brief Configuration data required to setup a \e filter
///
/// A \javamsgque filter application have to implement the #javamsgque.IFilter interface.
///
/// \attention the last filter application (the one with no other filer application following)
/// have to implement the \c FTR and the \c EOF function but set the \c filter variable to
/// \b false
public interface IFilter extends IServer {
  /// \api #MqConfigS::isFilter
  public static final boolean filter  = true;
  /// \api #MqConfigS::fFTR
  void FTR ();
  /// \api #MqConfigS::fEOF
  void EOF ();
}





