/**
 *  \file       javamsgque/IServer.java
 *  \brief      \$Id: IServer.java 1048 2009-04-19 06:14:02Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1048 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

package javamsgque;

/// \brief Configuration data required to setup a \e server
///
/// A \javamsgque server application have to implement the #javamsgque.IServer interface.
public interface IServer extends IClient {
  /// \api #MqConfigS::isServer
  public static final boolean server  = true;

  /// This function is used to configure a new context and act like
  /// constructor. A context is created for every new incomming connection 
  /// request and is used to provide context specific services 
  /// (#javamsgque.MqS.ServiceCreate) or to init context specific data.
  void ServerConfig ();
} ;






