/**
 *  \file       javamsgque/config_java.c
 *  \brief      \$Id: config_java.c 1182 2009-05-15 13:59:20Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1182 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "context_java.h"

extern jfieldID NS(FID_MqS_hdl);
extern jclass	NS(Class_NullPointerException);

JNIEXPORT jint JNICALL NS(MqS_ConfigGetDebug) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  return (jint) msgque->config.debug;
error:
  return 0;
}

JNIEXPORT jboolean JNICALL NS(MqS_ConfigGetIsString) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  return (msgque->config.isString == MQ_YES ? JNI_TRUE : JNI_FALSE);
error:
  return JNI_FALSE;
}

JNIEXPORT jboolean JNICALL NS(MqS_ConfigGetIsSilent) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  return (msgque->config.isSilent == MQ_YES ? JNI_TRUE : JNI_FALSE);
error:
  return JNI_FALSE;
}

JNIEXPORT jboolean JNICALL NS(MqS_ConfigGetIsServer) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  return (msgque->config.isServer == MQ_YES ? JNI_TRUE : JNI_FALSE);
error:
  return JNI_FALSE;
}

JNIEXPORT jboolean JNICALL NS(MqS_ConfigGetIsParent) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  return (msgque->config.parent == NULL ? JNI_TRUE : JNI_FALSE);
error:
  return JNI_FALSE;
}

JNIEXPORT jboolean JNICALL NS(MqS_ConfigGetIsSlave) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  return (msgque->config.master != NULL ? JNI_TRUE : JNI_FALSE);
error:
  return JNI_FALSE;
}

JNIEXPORT jobject JNICALL NS(MqS_ConfigGetParent) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  if (msgque->config.parent == NULL) {
    return NULL;
  } else {
    return ((struct JavaContextS *)msgque->config.parent->config.myCtx)->self;
  }
error:
    return NULL;
}

JNIEXPORT jobject JNICALL NS(MqS_ConfigGetMaster) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  if (msgque->config.master == NULL) {
    return NULL;
  } else {
    return ((struct JavaContextS *)msgque->config.master->config.myCtx)->self;
  }
error:
  return NULL;
}

JNIEXPORT jstring JNICALL NS(MqS_ConfigGetName) (
  JNIEnv    *env, 
  jobject   self
)
{
  const char * str;
  SETUP_msgque;
  str = msgque->config.name;
  return (*env)->NewStringUTF(env,str);
error:
    return NULL;
}

JNIEXPORT jint JNICALL NS(MqS_ConfigGetCtxId) (
  JNIEnv    *env, 
  jobject   self
)
{
  SETUP_msgque;
  return MqGetCtxId(msgque);
error:
  return 0;
}

JNIEXPORT jstring JNICALL NS(MqS_ConfigGetToken) (
  JNIEnv    *env, 
  jobject   self
)
{
  char const * str;
  SETUP_msgque;
  str = MqGetToken(msgque);
  return (*env)->NewStringUTF(env,str);
error:
  return 0;
}

