/**
 *  \file       javamsgque/context_java.h
 *  \brief      \$Id: context_java.h 1182 2009-05-15 13:59:20Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1182 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef JAVACONTEXT_H
#define JAVACONTEXT_H

#include <string.h>
#include <stdlib.h>

#include "msgque.h"

// public visible names with package prefix
#define NS(n)	Java_javamsgque_ ## n

#include "javamsgque_MqS.h"
#include "misc_java.h"

#define MQ_IS_POSIX
#include "../src/debug.h"

/*****************************************************************************/
/*                                                                           */
/*                              context_basic                                */
/*                                                                           */
/*****************************************************************************/

/// \brief object to link the \libmsgque object with application specific data
struct JavaContextS {
  struct MqS * msgque;		///< link to the \libmsgque object
  JNIEnv *env;			///< current JAVA object class environment
  jclass class;			///< current JAVA object class
  jobject self;			///< current JAVA object
  MQ_BOL onDelete;		///< Is this context allready in deletion?
  MQ_INT callLevel;             ///< code evaluated by "ProcCall" ?
  jmethodID factoryConstr;	///< default constructor used by the factory
};

#define SETUP_msgque \
  struct MqS * msgque = ((struct MqS *) (*env)->GetLongField(env,self,NS(FID_MqS_hdl))); \
  if (msgque == NULL) { \
    (*env)->ThrowNew(env, NS(Class_NullPointerException), "javamsgque object already deleted");\
    goto error; \
  }

#define SETUP_buffer \
  buffer = ((MQ_BUF) (*env)->GetLongField(env,buf,NS(FID_Buffer_hdl))); \
  if (buffer == NULL) { \
    (*env)->ThrowNew(env, NS(Class_NullPointerException), "javamsgque buffer object already deleted");\
    goto error; \
  }

#define SETUP_context \
  context = (struct JavaContextS *) msgque->config.myCtx;

#define CONTEXT ((struct JavaContextS *) msgque->config.myCtx)

#endif /* JAVACONTEXT_H */


