/**
 *  \file       javamsgque/get_java.c
 *  \brief      \$Id: get_java.c 1182 2009-05-15 13:59:20Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1182 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "context_java.h"

extern jfieldID NS(FID_MqS_hdl);
extern jfieldID NS(FID_Buffer_hdl);
extern jclass	NS(Class_NullPointerException);
extern jclass	NS(Class_RuntimeException);

JNIEXPORT jchar JNICALL 
NS(MqS_GetType) (
  JNIEnv *  env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  return MqBufferGetType(buffer);
error:
  return 0;
}

JNIEXPORT jbyte JNICALL 
NS(MqS_GetY) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_BYT v;
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqBufferGetY(msgque->error,buffer,&v));
  return (jbyte) v;
error:
  return 0;
}

JNIEXPORT jboolean JNICALL 
NS(MqS_GetO) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_BOL v;
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqBufferGetO(msgque->error,buffer,&v));
  return (jboolean) v;
error:
  return 0;
}

JNIEXPORT jshort JNICALL 
NS(MqS_GetS) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_SRT v;
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqBufferGetS(msgque->error,buffer,&v));
  return (jshort) v;
error:
  return 0;
}

JNIEXPORT jint JNICALL 
NS(MqS_GetI) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_INT v;
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqBufferGetI(msgque->error,buffer,&v));
  return (jint) v;
error:
  return 0;
}

JNIEXPORT jfloat JNICALL 
NS(MqS_GetF) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_FLT v;
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqBufferGetF(msgque->error,buffer,&v));
  return (jfloat) v;
error:
  return 0;
}

JNIEXPORT jlong JNICALL 
NS(MqS_GetW) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_WID v;
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqBufferGetW(msgque->error,buffer,&v));
  return (jlong) v;
error:
  return 0L;
}

JNIEXPORT jdouble JNICALL 
NS(MqS_GetD) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_DBL v;
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqBufferGetD(msgque->error,buffer,&v));
  return (jdouble) v;
error:
  return 0.0;
}

JNIEXPORT jobject JNICALL 
NS(MqS_GetC) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  MQ_STR v = "";
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqBufferGetC(msgque->error,buffer,&v));
  return (*env)->NewStringUTF(env,v);
error:
  return NULL;
}

JNIEXPORT jobject JNICALL 
NS(MqS_GetB) (
  JNIEnv    *env, 
  jobject   self, 
  jobject   buf
)
{
  jbyteArray tmp;
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  tmp = (*env)->NewByteArray(env,buffer->cursize);
  (*env)->SetByteArrayRegion(env,tmp,0,buffer->cursize,(jbyte*)buffer->data);
  return tmp;
error:
  return NULL;
}

JNIEXPORT void JNICALL NS(MqS_GetL_1START)(
  JNIEnv *  env, 
  jobject   self,
  jobject   buf
)
{
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToJavaWithCheck(MqReadL_START(msgque->read, buffer));
error:
  return;
}

JNIEXPORT void JNICALL NS(MqS_GetL_1END) (
  JNIEnv *  env, 
  jobject   self 
)
{
  SETUP_msgque;
  MqReadL_END(msgque->read);
error:
  return;
}

