/**
 *  \file       javamsgque/misc_java.h
 *  \brief      \$Id: misc_java.h 1128 2009-05-06 11:37:30Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1128 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef MISC_JAVA_H
#define MISC_JAVA_H

#define ErrorStringToJava(err) NS(pErrorFromString)(env, __func__, __FILE__, __LINE__, err)
#define ErrorMqToJava() NS(pErrorFromMq)(env, __func__, __FILE__, __LINE__, msgque)
#define ErrorMqToJavaWithCheck(PROC) \
  if (unlikely((PROC) == MQ_ERROR)) { \
    ErrorMqToJava(); \
    goto error; \
  }
#define JavaErrorCheck(PROC) PROC; \
if ((*env)->ExceptionCheck(env) == JNI_TRUE) goto error;

MQ_STR NS(pGetStringFromStaticJavaField)    ( JNIEnv *, jclass, const char*, const char*);
MQ_BOL NS(pGetBoolFromStaticJavaField)	    ( JNIEnv *, jclass, const char*, const char*);
MQ_INT NS(pGetIntFromStaticJavaField)	    ( JNIEnv *, jclass, const char*, const char*);

enum MqErrorE	NS(ProcCall)			( struct MqS *, jobject, jclass, jmethodID, jobject);
void		NS(pErrorFromString)		( JNIEnv *, const char *, const char *, const int, const char*);
void		NS(pErrorFromMq)		( JNIEnv *, const char *, const char *, const int, struct MqS *const);
jmethodID	NS(pGetMethodIdFromObjectField)	( JNIEnv *, jobject, const char *);
enum MqErrorE	NS(pErrorJavaToMq)		( JNIEnv *, struct MqS *);
const char*	NS(pGetClassName)		( JNIEnv *, jclass );

#endif /* MISC_JAVA_H */












