/**
 *  \file       javamsgque/slave_java.c
 *  \brief      \$Id: slave_java.c 129 2009-06-30 12:10:31Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 129 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "context_java.h"

extern jfieldID NS(FID_MqS_hdl);
extern jclass NS(Class_NullPointerException);

JNIEXPORT void JNICALL NS(MqS_SlaveCreate) (
  JNIEnv *  env, 
  jobject   self, 
  jint	    id,
  jobject   slave
)
{
  SETUP_msgque;
  ErrorMqToJavaWithCheck(MqSlaveCreate(msgque, id,
    ((struct MqS *) (*env)->GetLongField(env,slave,NS(FID_MqS_hdl)))
  ));
error:
  return;
}

JNIEXPORT void JNICALL NS(MqS_SlaveDelete) (
  JNIEnv *  env, 
  jobject   self, 
  jint	    id
)
{
  SETUP_msgque;
  ErrorMqToJavaWithCheck(MqSlaveDelete (msgque, id));
error:
  return;
}

JNIEXPORT jobject JNICALL NS(MqS_SlaveGet) (
  JNIEnv *  env, 
  jobject   self, 
  jint	    id
)
{
  struct MqS * slave;
  SETUP_msgque;

  slave = MqSlaveGet(msgque, id);

  return (slave == NULL ? NULL : ((struct JavaContextS *)slave->config.myCtx)->self);
error:
  return NULL;
}

