#!/bin/sh
#+
#§  \file       make_binary_dist.sh
#§  \brief      \$Id:$
#§  
#§  (C) 2009 - LibMsgque - Project - Group
#§  
#§  \version    \$Rev:$
#§  \author     EMail: aotto1968 at users.sourceforge.net
#§  \attention  this software has GPL permissions to copy
#§              please contact AUTHORS for additional information
#§


test ! -f ./env.sh && {
  echo "ERROR: you have to run the './configure' script first"
  exit 1
}
set -x
. ./env.sh
TOPDIR="$PWD"

make dist

rm -fr binary-build
mkdir binary-build
cd binary-build

tar -xf ../$PACKAGE-$PACKAGE_VERSION.tar.gz

cd $PACKAGE-$PACKAGE_VERSION

PKG=${PACKAGE}-${PACKAGE_VERSION}-${host}
FINAL_PKG=$TOPDIR/binary-dist/$PKG.zip

export PATH=$HOME/ext/$MACHTYPE/thread/bin:$PATH

ARGS=""
test "$JAVA" != "" && ARGS="$ARGS --enable-java"
test "$PYTHON" != "" && ARGS="$ARGS --enable-python"
test "$CSEXEC" != "" && ARGS="$ARGS --enable-csharp"

if [[ $build == *cygwin* ]] ; then
  bash ./configure    CC="gcc -mno-cygwin" \
		      --host=i686-pc-mingw32 \
		      --build=i686-pc-cygwin \
		      --prefix=/usr/local \
		       --enable--threads $ARGS

  mv libtool libtool.bak
  sed 's,libname_spec="\lib,libname_spec=",' libtool.bak > libtool
  chmod u+x libtool
else
  bash ./configure --prefix=/usr/local --enable-threads $ARGS
fi

make || exit 1

test -d /tmp/$PKG || mkdir /tmp/$PKG

make DESTDIR=/tmp/$PKG install || exit 1

test -f $FINAL_PKG && rm $FINAL_PKG

(cd /tmp; zip -r $FINAL_PKG $PKG)

make uninstall

test -d /tmp/$PKG && rm -fr /tmp/$PKG
