/**
 *  \file       pymsgque/config_python.c
 *  \brief      \$Id: config_python.c 1108 2009-04-30 12:38:56Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1108 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "msgque_python.h"

PyObject* NS(ConfigGetDebug) (
  PyObject    *self
)
{
  SETUP_msgque;
  return PyLong_FromLong(msgque->config.debug);
error:
  return NULL;
}

PyObject* NS(ConfigGetIsString) (
  PyObject    *self
)
{
  SETUP_msgque;
  if (msgque->config.isString == MQ_YES) {
    Py_RETURN_TRUE;
  } else {
    Py_RETURN_FALSE;
  }
error:
  return NULL;
}

PyObject* NS(ConfigGetIsServer) (
  PyObject    *self
)
{
  SETUP_msgque;
  if (msgque->config.isServer == MQ_YES) {
    Py_RETURN_TRUE;
  } else {
    Py_RETURN_FALSE;
  }
error:
  return NULL;
}

PyObject* NS(ConfigGetIsParent) (
  PyObject    *self
)
{
  SETUP_msgque;
  if (msgque->config.parent == NULL) {
    Py_RETURN_TRUE;
  } else {
    Py_RETURN_FALSE;
  }
error:
  return NULL;
}

PyObject* NS(ConfigGetIsSlave) (
  PyObject    *self
)
{
  SETUP_msgque;
  if (msgque->config.master == NULL) {
    Py_RETURN_FALSE;
  } else {
    Py_RETURN_TRUE;
  }
error:
  return NULL;
}

PyObject* NS(ConfigGetIsSilent) (
  PyObject    *self
)
{
  SETUP_msgque;
  if (msgque->config.isSilent == MQ_YES) {
    Py_RETURN_TRUE;
  } else {
    Py_RETURN_FALSE;
  }
error:
  return NULL;
}

PyObject* NS(ConfigGetParent) (
  PyObject    *self,
  PyObject    *args
)
{
  SETUP_msgque;
  if (msgque->config.parent == NULL) {
    Py_RETURN_NONE;
  } else {
    PyObject *parent = (PyObject*) ((struct PythonContextS *)msgque->config.parent->config.myCtx)->self;
    Py_INCREF(parent);
    return parent;
  }
error:
  return NULL;
}

PyObject* NS(ConfigGetName) (
  PyObject    *self,
  PyObject    *args
)
{
  SETUP_msgque;
  return PyUnicode_FromString(msgque->config.name);
error:
  return NULL;
}

PyObject* NS(ConfigGetCtxId) (
  PyObject    *self,
  PyObject    *args
)
{
  SETUP_msgque;
  return PyLong_FromLong(MqGetCtxId(msgque));
error:
  return NULL;
}

PyObject* NS(ConfigGetToken) (
  PyObject    *self,
  PyObject    *args
)
{
  SETUP_msgque;
  return PyUnicode_FromString(MqGetToken(msgque));
error:
  return NULL;
}

PyObject* NS(ConfigGetMaster) (
  PyObject  *self 
)
{
  SETUP_msgque;
  if (msgque->config.master == NULL) {
    Py_RETURN_NONE;
  } else {
    PyObject *masterO = (PyObject*) ((struct PythonContextS *)msgque->config.master->config.myCtx)->self;
    Py_INCREF(masterO);
    return masterO;
  }
error:
  return NULL;
}

