/**
 *  \file       pymsgque/get_python.c
 *  \brief      \$Id: get_python.c 1182 2009-05-15 13:59:20Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1182 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "msgque_python.h"

PyObject* NS(GetType) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  char str[2] = { '\0', '\0' };
  SETUP_msgque;
  SETUP_buffer;
  str[0] = MqBufferGetType(buffer);
    
  return PyUnicode_FromString(str);
error:
  return NULL;
}

PyObject* NS(GetY) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  MQ_BYT v;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqBufferGetY(msgque->error,buffer,&v));
  return PyLong_FromLong(v);
error:
  return NULL;
}

PyObject* NS(GetO) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  MQ_BOL v;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqBufferGetO(msgque->error,buffer,&v));
  if (v == MQ_YES) {
    Py_RETURN_TRUE;
  } else {
    Py_RETURN_FALSE;
  }
error:
  return NULL;
}

PyObject* NS(GetS) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  MQ_SRT v;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqBufferGetS(msgque->error,buffer,&v));
  return PyLong_FromLong(v);
error:
  return NULL;
}

PyObject* NS(GetI) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  MQ_INT v;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqBufferGetI(msgque->error,buffer,&v));
  return PyLong_FromLong(v);
error:
  return NULL;
}

PyObject* NS(GetF) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  MQ_FLT v;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqBufferGetF(msgque->error,buffer,&v));
  return PyFloat_FromDouble((double)v);
error:
  return NULL;
}

PyObject* NS(GetW) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  MQ_WID v;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqBufferGetW(msgque->error,buffer,&v));
  return PyLong_FromLongLong((PY_LONG_LONG)v);
error:
  return NULL;
}

PyObject* NS(GetD) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  MQ_DBL v;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqBufferGetD(msgque->error,buffer,&v));
  return PyFloat_FromDouble(v);
error:
  return NULL;
}

PyObject* NS(GetC) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  MQ_STR v;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqBufferGetC(msgque->error,buffer,&v));
  return PyUnicode_FromString(v);
error:
  return NULL;
}

PyObject* NS(GetB) (
  PyObject  *self,
  PyObject  *buf
)
{ 
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  return PyByteArray_FromStringAndSize((const char*)buffer->data, buffer->cursize);
error:
  return NULL;
}

PyObject* NS(GetL_START)(
  PyObject*	self,
  PyObject*	buf
)
{
  MQ_BUF buffer;
  SETUP_msgque;
  SETUP_buffer;
  ErrorMqToPythonWithCheck(MqReadL_START(msgque->read, buffer));
  Py_RETURN_NONE;
error:
  return NULL;
}

PyObject* NS(GetL_END) (
  PyObject*	self 
)
{
  SETUP_msgque;
  MqReadL_END(msgque->read);
  Py_RETURN_NONE;
error:
  return NULL;
}
