/**
 *  \file       pymsgque/slave_python.c
 *  \brief      \$Id: slave_python.c 129 2009-06-30 12:10:31Z dev1usr $
 *  
 *  (C) 2009 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 129 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "msgque_python.h"

#define MSGQUE msgque

extern PyTypeObject NS(MqS_Type);

PyObject* NS(SlaveCreate) (
  PyObject  *self, 
  PyObject  *args
)
{
  int id;
  PyObject *slaveO;
  SETUP_msgque;

  if (!PyArg_ParseTuple(args, "iO!:SlaveCreate", &id, &NS(MqS_Type), &slaveO)) {
    return NULL;
  }

  // create the service
  ErrorMqToPythonWithCheck(MqSlaveCreate (msgque, id, ((PyMqs_Obj*)slaveO)->msgque));
  Py_RETURN_NONE;
error:
  return NULL;
}

PyObject* NS(SlaveDelete) (
  PyObject  *self, 
  PyObject  *args
)
{
  int id;
  SETUP_msgque;

  if (!PyArg_ParseTuple(args, "i:SlaveDelete", &id)) {
    return NULL;
  }

  // create the service
  ErrorMqToPythonWithCheck(MqSlaveDelete (msgque, id));
  Py_RETURN_NONE;
error:
  return NULL;
}

PyObject* NS(SlaveGet) (
  PyObject  *self, 
  PyObject  *args
)
{
  struct MqS * slave;
  int id;
  SETUP_msgque;

  if (!PyArg_ParseTuple(args, "i:SlaveGet", &id)) {
    return NULL;
  }

  slave = MqSlaveGet(msgque, id);

  if (slave == NULL) {
    Py_RETURN_NONE;
  } else {
    PyObject *slaveO = (PyObject*) ((struct PythonContextS *)slave->config.myCtx)->self;
    Py_INCREF(slaveO);
    return slaveO;
  }
error:
  return NULL;
}

