/**
 *  \file       src/cache.h
 *  \brief      \$Id: cache.h 1033 2009-04-10 10:36:50Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1033 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef CACHE_H
#define CACHE_H

/*****************************************************************************/
/*                                                                           */
/*                              cache_init                                   */
/*                                                                           */
/*****************************************************************************/

typedef MQ_PTR (
  *CacheCF
) (
  MQ_PTR const
);

typedef void (
  *CacheDF
) (
  MQ_PTR * const
);

void
 pCacheCreate (
  struct MqErrorS * const error,
  CacheCF createF,
  CacheDF deleteF,
  MQ_PTR createD,
  struct MqCacheS ** const out
);

void
 pCacheDelete (
  struct MqCacheS ** const out
) __attribute__((nonnull));

/*****************************************************************************/
/*                                                                           */
/*                              cache_1                                      */
/*                                                                           */
/*****************************************************************************/

MQ_PTR
 pCachePop (
  register struct MqCacheS * const top
);

void
 pCachePush (
  register struct MqCacheS * const top,
  MQ_PTR data
);

#endif
