/**
 *  \file       src/error.h
 *  \brief      \$Id: error.h 1176 2009-05-14 13:57:36Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1176 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef ERROR_H
#   define ERROR_H

void pErrorCreate (
  struct MqS const * const msgque,
  struct MqErrorS ** const out
);

void pErrorDelete (
  struct MqErrorS ** const errorP
) __attribute__((nonnull));

enum MqErrorE pErrorSet (
  struct MqErrorS * const error,
  MQ_INT const errnum,
  MQ_STRB const * const errtext,
  MQ_BOL const append
);

MQ_INLINE void pErrorAppendC (
  struct MqErrorS const * const error,
  MQ_STR msg
);

void
pErrorReport(
  struct MqErrorS * const error
);

void
pErrorSync (
  struct MqErrorS * const out,
  struct MqErrorS * const in
);

#define MqErrorDb(item) \
    MqErrorSGenV(MQ_ERROR_S,__func__,MQ_ERROR,(item+200),MqMessageText[item])

#define MqErrorDb2(error,item) \
    MqErrorSGenV(error,__func__,MQ_ERROR,(item+200),MqMessageText[item])

#define MqErrorDbV(item, ...) \
    MqErrorSGenV(MQ_ERROR_S,__func__,MQ_ERROR,(item+200),MqMessageText[item], __VA_ARGS__)

#define MqErrorDbV2(error,item, ...) \
    MqErrorSGenV(error,__func__,MQ_ERROR,(item+200),MqMessageText[item], __VA_ARGS__)

#endif /* ERROR_H */


