/**
 *  \file       src/event.h
 *  \brief      \$Id: event.h 1033 2009-04-10 10:36:50Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1033 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef EVENT_H
#   define EVENT_H

struct MqEventS;

void pEventAdd ( struct MqS * const , MQ_SOCK * const);

enum MqErrorE pEventCheck (
  struct MqErrorS * const error,
  struct MqEventS * event,
  enum MqIoSelectE const typ,
  struct timeval * const timeout
);

enum MqErrorE pEventStart (
  struct MqErrorS * const error,
  struct MqEventS * event,
  struct timeval const * const timeout,
  EventCreateF const proc
);

enum MqErrorE pEventCreate (
  struct MqS const * const msgque,
  struct MqEventS ** const eventP
);

void pEventDelete ( struct MqS const * const );

#if _DEBUG
void pEventLog( struct MqS const * const , struct MqEventS *, MQ_STRB const * const);
#endif

#endif /* EVENT_H */
