/**
 *  \file       src/io_private.h
 *  \brief      \$Id: io_private.h 1033 2009-04-10 10:36:50Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1033 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef IO_PRIVATE_H
#   define IO_PRIVATE_H

#   define IO_SAVE_ERROR(io) ((io)?MQ_SAVE_ERROR((io)->msgque):NULL)

#   include "mq_io.h"
#   include "sys_com.h"

/// \brief everything \e io need for local storage
struct MqIoS {
  struct MqS * msgque;		    ///< link to 'msgque' object
  enum IoComE com;		    ///< Commmunication-Type IO_UDS or IO_TCP
  union {
#if defined(MQ_IS_POSIX)
    struct UdsS *   udsSP;	    ///< UDS object pointer
#endif
    struct TcpS *   tcpSP;	    ///< TCP object pointer
    struct PipeS *  pipeSP;	    ///< PIPE object pointer
  } iocom;			    ///< link to 'iocom' object
  fd_set fdset;			    ///< select need this
  MQ_SOCK *sockP;		    ///< pointer to the current socket
  struct MqIdS id;		    ///< (pid_t/mqthread_t) id of the server in "pipe" mode
  struct MqEventS * event;	    ///< link to the according Event structure
  MQ_INT buffersize;		    ///< CLIENT: buffersize for connect
  MQ_TIME_T timeout;		    ///< CLIENT: timeout for connect, send and recv
};

#endif /* IO_PRIVATE_H */
