/**
 *  \file       src/pipe_io.h
 *  \brief      \$Id: pipe_io.h 1176 2009-05-14 13:57:36Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1176 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef PIPE_IO_H
#   define PIPE_IO_H

#   define PIPE_SAVE_ERROR(pipe) ((pipe)?IO_SAVE_ERROR((pipe)->io):NULL)

/*****************************************************************************/
/*                                                                           */
/*                                  pipe_io                                   */
/*                                                                           */
/*****************************************************************************/

void PipeCleanup (
  struct MqErrorS * const error,
  struct MqBufferLS * const argv
);

enum MqErrorE PipeCreate (
  struct MqIoS * const io,
  struct MqBufferLS * const argv,
  struct PipeS ** const pipePtr
);

void PipeDelete (
  struct PipeS ** const pipeP
) __attribute__((nonnull));

MQ_INLINE enum MqErrorE PipeServer (
  struct PipeS * const pipe
);

MQ_INLINE enum MqErrorE PipeConnect (
  struct PipeS * const pipe
);

/*****************************************************************************/
/*                                                                           */
/*                                pipe_arg                                    */
/*                                                                           */
/*****************************************************************************/

MQ_PTR PipeGetOpt (
  struct PipeS const * const pipe,
  int const opt
);

MQ_INLINE MQ_SOCK* PipeGetServerSocket (
  struct PipeS * const pipe
);


#endif /* PIPE_IO_H */

