/**
 *  \file       src/tcp_io.h
 *  \brief      \$Id: tcp_io.h 1176 2009-05-14 13:57:36Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1176 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef TCP_IO_H
#   define TCP_IO_H

#   define TCP_SAVE_ERROR(tcp) ((tcp)?IO_SAVE_ERROR((tcp)->io):NULL)

struct sockaddr_in;

/*****************************************************************************/
/*                                                                           */
/*                                 tcp_io                                    */
/*                                                                           */
/*****************************************************************************/

void TcpCleanup (
  struct MqErrorS * const error,
  struct MqBufferLS * const argv
);

enum MqErrorE TcpCreate (
  struct MqIoS * const io,
  struct MqBufferLS * const argv,
  struct TcpS ** const tcpPtr
);

void TcpDelete (
  struct TcpS ** const tcpP
) __attribute__((nonnull));

enum MqErrorE TcpServer (
  register struct TcpS * const tcp
);

enum MqErrorE TcpConnect (
  register struct TcpS * const tcp
);

#endif /* TCP_IO_H */


