/**
 *  \file       src/token.h
 *  \brief      \$Id: token.h 1033 2009-04-10 10:36:50Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1033 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#ifndef TOKEN_H
#   define TOKEN_H

/*****************************************************************************/
/*                                                                           */
/*                             token_init                                    */
/*                                                                           */
/*****************************************************************************/

enum MqErrorE pTokenCreate (
  struct MqS * const msgque,
  struct MqTokenS ** const out
);

enum MqErrorE pTokenDelete (
  register struct MqTokenS ** const tokenP
) __attribute__((nonnull));

/*****************************************************************************/
/*                                                                           */
/*                              token_misc                                   */
/*                                                                           */
/*****************************************************************************/

enum MqErrorE pTokenCheckSystem (
  register struct MqTokenS const * const token
);

/*
MQ_INLINE MQ_SIZE pTokenGetUsed (
  register struct MqTokenS const * const token
);
*/

MQ_INLINE enum MqErrorE pTokenInvoke (
  register struct MqTokenS const * const token
);

MQ_INLINE MQ_STRB const * pTokenGetCurrent (
  struct MqTokenS const * const token
);

MQ_INLINE void pTokenSetCurrent (
  struct MqTokenS * const token,
  MQ_STRB const * const str
);

MQ_INLINE MQ_BOL pTokenCheck (
  struct MqTokenS const * const token,
  MQ_STRB const * const str
);

enum MqErrorE pTokenAddHdl (
  struct MqTokenS const * const token,
  MQ_STRB const * const name,
  MqTokenF proc,
  MQ_PTR data,
  MqTokenDataFreeF datafreeF
);

enum MqErrorE pTokenDelHdl (
  struct MqTokenS const * const token,
  MQ_STRB const * const name
);

#endif /* TOKEN_H */




