/**
 *  \file       src/uds_io.h
 *  \brief      \$Id: uds_io.h 1033 2009-04-10 10:36:50Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1033 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#if defined(MQ_IS_POSIX)

#ifndef UDS_IO_H
#   define UDS_IO_H

#   define UDS_SAVE_ERROR(uds) ((uds)?IO_SAVE_ERROR((uds)->io):NULL)

/*****************************************************************************/
/*                                                                           */
/*                                  uds_io                                   */
/*                                                                           */
/*****************************************************************************/

void UdsCleanup (
  struct MqErrorS * const error,
  struct MqBufferLS * const argv
);

enum MqErrorE UdsCreate (
  struct MqIoS * const io,
  struct MqBufferLS * const argv,
  struct UdsS ** const udsPtr
);

enum MqErrorE UdsDelete (
  struct UdsS ** const udsP
) __attribute__((nonnull));

enum MqErrorE UdsServer (
  register struct UdsS * const uds
);

enum MqErrorE UdsConnect (
  register struct UdsS * const uds
);

/*****************************************************************************/
/*                                                                           */
/*                                uds_arg                                    */
/*                                                                           */
/*****************************************************************************/

#endif /* UDS_IO_H */

#endif /* MQ_IS_POSIX */

