/**
 *  \file       tclmsgque/config_tcl.c
 *  \brief      \$Id: config_tcl.c 1108 2009-04-30 12:38:56Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1108 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "msgque_tcl.h"

HD(ConfigGetToken)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetResult(context->interp, (char *)MqGetToken(msgque), TCL_VOLATILE);
  RETURN_TCL
}

HD(ConfigGetCtxId)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetObjResult(context->interp, Tcl_NewIntObj (MqGetCtxId(msgque)));
  RETURN_TCL
}

HD(ConfigGetDebug)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetObjResult(context->interp, Tcl_NewIntObj (msgque->config.debug));
  RETURN_TCL
}

HD(ConfigGetIsString)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetObjResult(context->interp, Tcl_NewBooleanObj (msgque->config.isString));
  RETURN_TCL
}

HD(ConfigGetIsSilent)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetObjResult(context->interp, Tcl_NewBooleanObj (msgque->config.isSilent));
  RETURN_TCL
}

HD(ConfigGetIsServer)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetObjResult(context->interp, Tcl_NewBooleanObj (msgque->config.isServer));
  RETURN_TCL
}

HD(ConfigGetIsParent)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetObjResult(context->interp, Tcl_NewBooleanObj (msgque->config.parent == NULL));
  RETURN_TCL
}

HD(ConfigGetIsSlave)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetObjResult(context->interp, Tcl_NewBooleanObj (msgque->config.master != NULL));
  RETURN_TCL
}

HD(ConfigGetName)
{
  SETUP_msgque
  CHECK_NOARGS
  Tcl_SetResult(context->interp, msgque->config.name, TCL_STATIC);
  RETURN_TCL
}

HD(ConfigGetParent)
{
  SETUP_msgque
  CHECK_NOARGS
  if (msgque->config.parent != NULL) {
    Tcl_SetObjResult(interp,((struct TclContextS*)msgque->config.parent->config.myCtx)->self);
  } else {
    Tcl_SetResult(interp,"", TCL_STATIC);
  }
  RETURN_TCL
}

HD(ConfigGetMaster)
{
  SETUP_msgque
  CHECK_NOARGS
  if (msgque->config.master != NULL)
    Tcl_SetObjResult(interp, ((struct TclContextS *)msgque->config.master->config.myCtx)->self);
  else
    Tcl_SetResult(interp, "", TCL_STATIC);
  RETURN_TCL
}

