/**
 *  \file       tclmsgque/get_tcl.c
 *  \brief      \$Id: get_tcl.c 1178 2009-05-15 07:25:57Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1178 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "msgque_tcl.h"

HD(GetL_START)
{
  MQ_BUF buffer;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqReadL_START(msgque->read, buffer));
  RETURN_TCL
}

HD(GetL_END)
{
  SETUP_msgque
  CHECK_NOARGS
  MqReadL_END(msgque->read);
  RETURN_TCL
}

HD(GetY)
{
  MQ_BUF buffer;
  MQ_BYT val;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqBufferGetY(msgque->error, buffer, &val));
  Tcl_SetObjResult(context->interp, Tcl_NewIntObj(val));
  RETURN_TCL
}

HD(GetO)
{
  MQ_BUF buffer;
  MQ_BOL val;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqBufferGetO(msgque->error, buffer, &val));
  Tcl_SetObjResult(context->interp, Tcl_NewBooleanObj(val));
  RETURN_TCL
}

HD(GetS)
{
  MQ_BUF buffer;
  MQ_SRT val;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqBufferGetS(msgque->error, buffer, &val));
  Tcl_SetObjResult(context->interp, Tcl_NewIntObj(val));
  RETURN_TCL
}

HD(GetI)
{
  MQ_BUF buffer;
  MQ_INT val;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqBufferGetI(msgque->error, buffer, &val));
  Tcl_SetObjResult(context->interp, Tcl_NewIntObj(val));
  RETURN_TCL
}

HD(GetF)
{
  MQ_BUF buffer;
  MQ_FLT val;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqBufferGetF(msgque->error, buffer, &val));
  Tcl_SetObjResult(context->interp, Tcl_NewDoubleObj(val));
  RETURN_TCL
}

HD(GetW)
{
  MQ_BUF buffer;
  MQ_WID val;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqBufferGetW(msgque->error, buffer, &val));
  Tcl_SetObjResult(context->interp, Tcl_NewWideIntObj(val));
  RETURN_TCL
}

HD(GetD)
{
  MQ_BUF buffer;
  MQ_DBL val;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqBufferGetD(msgque->error, buffer, &val));
  Tcl_SetObjResult(context->interp, Tcl_NewDoubleObj(val));
  RETURN_TCL
}

HD(GetC)
{
  MQ_BUF buffer;
  MQ_STR val;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqBufferGetC(msgque->error, buffer, &val));
  Tcl_SetResult(context->interp, val, TCL_VOLATILE);
  RETURN_TCL
}

HD(GetB)
{
  MQ_BUF buffer;
  CHECK_U(buffer)
  CHECK_NOARGS
  Tcl_SetObjResult(context->interp, Tcl_NewByteArrayObj(buffer->cur.B,buffer->cursize));
  RETURN_TCL
}

HD(GetType)
{
  MQ_BUF buffer;
  char str[] = { '\0', '\0' };
  CHECK_U(buffer)
  CHECK_NOARGS
  str[0] = MqBufferGetType(buffer);
  Tcl_SetResult(context->interp, str, TCL_VOLATILE);
  RETURN_TCL
}

