/**
 *  \file       tclmsgque/send_tcl.c
 *  \brief      \$Id: send_tcl.c 1178 2009-05-15 07:25:57Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1178 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "msgque_tcl.h"

HD(SendSTART)
{
  SETUP_msgque
  CHECK_NOARGS
  MqSendSTART(msgque->send);
  RETURN_TCL
}

HD(SendEND)
{
  MQ_STR token;
  SETUP_msgque
  CHECK_C(token)
  MqSendEND(msgque->send,token);
  RETURN_TCL
}

HD(SendEND_AND_WAIT)
{
  MQ_STR token;
  MQ_INT timeout=MQ_TIMEOUT;
  SETUP_msgque
  CHECK_C(token)
  CHECK_DI(timeout)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqSendEND_AND_WAIT(msgque->send,token,timeout));
  RETURN_TCL
}

HD(SendEND_AND_CALLBACK)
{
  MQ_STR token;
  Tcl_Obj *callback;
  SETUP_msgque
  CHECK_C(token)
  CHECK_OBJ(callback)
  CHECK_NOARGS
  Tcl_IncrRefCount(callback);
  ErrorMqToTclWithCheck(MqSendEND_AND_CALLBACK(msgque->send, token, NS(ProcCall), callback, NS(ProcFree)));
  RETURN_TCL
}

HD(SendRETURN)
{
  SETUP_msgque
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqSendRETURN(msgque->send));
  RETURN_TCL
}

HD(SendFTR)
{
  MQ_INT timeout=MQ_TIMEOUT;
  SETUP_msgque
  CHECK_DI(timeout)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqSendFTR(msgque->send, timeout));
  RETURN_TCL
}

HD(SendEOF)
{
  MQ_INT timeout=MQ_TIMEOUT;
  SETUP_msgque
  CHECK_DI(timeout)
  CHECK_NOARGS
  ErrorMqToTclWithCheck(MqSendEOF(msgque->send, timeout));
  RETURN_TCL
}

HD(SendY)
{
  MQ_BYT val;
  SETUP_msgque
  CHECK_Y(val)
  CHECK_NOARGS
  MqSendY(msgque->send, val);
  RETURN_TCL
}

HD(SendO)
{
  MQ_BOL val;
  SETUP_msgque
  CHECK_O(val)
  CHECK_NOARGS
  MqSendO(msgque->send, val);
  RETURN_TCL
}

HD(SendS)
{
  MQ_SRT val;
  SETUP_msgque
  CHECK_S(val)
  CHECK_NOARGS
  MqSendS(msgque->send, val);
  RETURN_TCL
}

HD(SendI)
{
  MQ_INT val;
  SETUP_msgque
  CHECK_I(val)
  CHECK_NOARGS
  MqSendI(msgque->send, val);
  RETURN_TCL
}

HD(SendF)
{
  MQ_FLT val;
  SETUP_msgque
  CHECK_F(val)
  CHECK_NOARGS
  MqSendF(msgque->send, val);
  RETURN_TCL
}

HD(SendW)
{
  MQ_WID val;
  SETUP_msgque
  CHECK_W(val)
  CHECK_NOARGS
  MqSendW(msgque->send, val);
  RETURN_TCL
}

HD(SendD)
{
  MQ_DBL val;
  SETUP_msgque
  CHECK_D(val)
  CHECK_NOARGS
  MqSendD(msgque->send, val);
  RETURN_TCL
}

HD(SendC)
{
  MQ_STR val;
  SETUP_msgque
  CHECK_C(val)
  CHECK_NOARGS
  MqSendC(msgque->send, val);
  RETURN_TCL
}

HD(SendB)
{
  MQ_BIN val;
  MQ_SIZE len;
  SETUP_msgque
  CHECK_B(val,len)
  CHECK_NOARGS
  MqSendB(msgque->send, val, len);
  RETURN_TCL
}

HD(SendU)
{
  MQ_BUF buffer;
  SETUP_msgque
  CHECK_U(buffer)
  CHECK_NOARGS
  MqSendU(msgque->send, buffer);
  RETURN_TCL
}

HD(SendL_START)
{
  SETUP_msgque
  CHECK_NOARGS
  MqSendL_START(msgque->send);
  RETURN_TCL
}

HD(SendL_END)
{
  SETUP_msgque
  CHECK_NOARGS
  MqSendL_END(msgque->send);
  RETURN_TCL
}



