/**
 *  \file       tclmsgque/slave_tcl.c
 *  \brief      \$Id: slave_tcl.c 92 2009-06-22 10:28:11Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 92 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

#include "msgque_tcl.h"

#define MSGQUE msgque

HD(SlaveCreate)
{
  MQ_SIZE id;
  struct MqS *slave;
  SETUP_msgque
  CHECK_I(id)
  CHECK_MSGQUE(slave)
  CHECK_NOARGS
  ErrorMqToTclWithCheck (MqSlaveCreate (msgque, id, slave));
  RETURN_TCL
}

HD(SlaveDelete)
{
  MQ_SIZE id;
  SETUP_msgque
  CHECK_I(id)
  CHECK_NOARGS
  ErrorMqToTclWithCheck (MqSlaveDelete (msgque, id));
  RETURN_TCL
}

HD(SlaveGet)
{
  struct MqS * slave;
  MQ_SIZE id;
  SETUP_msgque
  CHECK_I(id)
  slave = MqSlaveGet(msgque, id);
  if (slave == NULL)
    Tcl_SetResult(interp, "", TCL_STATIC);
  else {
    Tcl_SetObjResult(interp, ((struct TclContextS *)slave->config.myCtx)->self);
  }
  RETURN_TCL
}
