/**
 *  \file       tests/server.c
 *  \brief      \$Id: server.c 1033 2009-04-10 10:36:50Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1033 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

/** \ingroup validation
 *  \defgroup server server
 *  \{
 *  \brief server \server_desc
 *
 *  \verbinclude server.help
 */
#include "server_context.h"
#include "debug.h"
#include <stdio.h>
#include <stdlib.h>

/*****************************************************************************/
/*                                                                           */
/*                                  main                                     */
/*                                                                           */
/*****************************************************************************/

/// \brief main entry-point for the tool
/// \param argc the number of command-line arguments
/// \param argv the command-line arguments as an array of strings
/// \return the exit number
int
main (
  int  const argc,
  char ** const argv
)
{
  // the parent-context
  struct MqS * msgque;
  struct MqConfigS *config = MqConfigInit();

  // parse the command-line
  struct MqBufferLS * largv;
  struct MqBufferLS * lalfa;
  MqBufferLCreateArgv (argc, argv, &largv, &lalfa);

  // create the ServerCtxS
  MqErrorCheck(ServerParentCreate (config, largv, lalfa, &msgque));

  // start event-loop and wait forever
  MqProcessEvent (msgque, MQ_TIMEOUT, MQ_WAIT_FOREVER);

  // finish and exit
error:
  MqExit (msgque);
}

/** \} server */
