/**
 *  \file       tests/server_context.h
 *  \brief      \$Id: server_context.h 1033 2009-04-10 10:36:50Z dev1usr $
 *  
 *  (C) 2004 - LibMsgque - Project - Group
 *  
 *  \version    \$Rev: 1033 $
 *  \author     EMail: aotto1968 at users.sourceforge.net
 *  \attention  this software has GPL permissions to copy
 *              please contact AUTHORS for additional information
 */

/** \addtogroup server
 * \{
 */

#ifndef SERVER_CONTEXT_H
#define SERVER_CONTEXT_H

#include "msgque.h"
#include "config.h"

/*****************************************************************************/
/*                                                                           */
/*                              context_basic                                */
/*                                                                           */
/*****************************************************************************/

/// \brief the local \b context of the \ref server tool
/// \msgque
struct ServerCtxS {
  struct MqS *	msgque;		///< \msgqueI
  MQ_BUF	val;		///< context specific data
  struct MqS *	cl[3];		///< \e MqSend* test client
  MQ_INT	i;		///< Callback value
};

/// \brief the local child \b context used in the Callback test
/// \msgque
struct ClientCtxS {
  struct MqS *	msgque;		///< \msgqueI
  struct ServerCtxS *	sv;	///< Callback server context
};

/*****************************************************************************/
/*                                                                           */
/*                                context_init                               */
/*                                                                           */
/*****************************************************************************/

enum MqErrorE ServerParentCreate (struct MqConfigS*, struct MqBufferLS*, struct MqBufferLS*, struct MqS**);

#endif /* SERVER_CONTEXT_H */

/** \} server */
